
.equ	EBI_BASE,0xFFE00000


	.global	__main
__main:	
	.long	InitReset		/* reset */
undefvec:	
	.long	undefvec		/* Undef */
swivec:
	.long	swivec			/* SW */
pabtvec:
	.long	pabtvec			/* P abt */
dabtvec:
	.long	dabtvec			/* D abt */
rsvdvec:
	.long	rsvdvec			/* reserved */
irqvec:
/*	ldr	pc, [pc,#-0xF20]	/* IRQ : read the AIC */
fiqvec:
/*	ldr	pc, [pc,#-0xF20]	/* FIQ : read the AIC */

InitReset:

/*
- | Initialise the Memory Controller
- | ---------------------------------
- | Copy the Image of the Memory Controller
*/
	mov	sp,#0x1000
	
	ldr	r10, PtInitTableEBI	/* get the address of the chip select register image */


	movs	r0, pc, LSR #20		/* pc > 0x100000 */

	moveq	r10, r10, LSL #12	/* Mask the 12 highest bits of the address */
	moveq	r10, r10, LSR #12

	/* Load the address where to jump */
	ldr	r12, PtInitRemap	/* get the real jump address ( after remap ) */

	/* Copy Chip Select Register Image to Memory Controller and command remap */
	ldmia	r10!, {r0-r9,r11}	/* load the complete image and the EBI base */
	stmia	r11!, {r0-r9}		/* store the complete image with the remap command */

	mov	pc, r12			/* jump and break the pipeline */


InitRemap:
	mov	pc,r12			/* just loop to ourselves for the time being */

/* 32,768 MHz master clock assumed */
PtInitTableEBI:
	.long	InitTableEBI            /* Table for EBI initialization */
PtInitRemap:
	.long	InitRemap               /* address where to jump after REMAP */

InitTableEBI:
	.long	0x0100203D		/* 0x01000000, 16MB, 0 hold, 16 bits, 8 WS */
	.long	0x02003121		/* 0x02000000, 16MB, 0 hold, 16 bits, 1 WS, Byte Select access */
	.long	0x20000000		/* unused */
	.long	0x30000000		/* unused */
	.long	0x40000000		/* unused */
	.long	0x50000000		/* unused */
	.long	0x60000000		/* unused */
	.long	0x70000000		/* unused */
	.long	0x00000001		/* REMAP command */
	.long	0x00000006		/* 7 memory regions, standard read */
	.long	EBI_BASE		/* EBI Base address */

            
