#include <stdio.h>

main(int argc, char *argv[])
{
	FILE *fp_in,*fp_out;
	long len,i;
	unsigned short data;

	if (argc < 3)
	{
		printf("Not enough filenames\n");
		printf("Usage: gen_progfile boot.bin prog_out\n");
		printf("boot.bin : input file\n");
		printf("prog_out : output C file\n");
		exit(-1);
	}

	if ((fp_in = fopen(argv[1],"rb")) == NULL)
	{
		printf("Error file <%s> cannot be opened for reading\n",argv[1]);
		exit(-1);
	}
	if ((fp_out = fopen(argv[2],"w")) == NULL)
	{
		fclose(fp_in);
		printf("Error file <%s> cannot be opened for output\n",argv[2]);
		exit(-1);
	}	
	fseek(fp_in,0,2);
	len = ftell(fp_in);
	printf("Filelength = %ld\n",len);
	fseek(fp_in,0,0);
	fprintf(fp_out,"#define PROG_ARRAY_SIZE	%d\n",len/2);
	fprintf(fp_out,"unsigned short prog_array[PROG_ARRAY_SIZE] = {\n");
	for(i=0;i<len/2;i++)
	{
		fread(&data,1,sizeof(data),fp_in);
		fprintf(fp_out,"\t\t%4.4#x,\n",data);

	}
	fprintf(fp_out,"};\n");
	fprintf(fp_out,"long prog_array_size(){return((long)PROG_ARRAY_SIZE);}\n");
	fclose(fp_in);
	fclose(fp_out);
}


